; 
; This program displays the information returned by the VBE
; Return VBE Controller Information function.
;
; Tested under Windows 2000 only.
;
; Under Windows 2000 and probably Windows XP, the Return VBE
; Controller Information function will fail if this program
; is running in a window.
; 
    .model small,c
    .386
    .stack
    include support.asm

    VbeInfoBlock struct
      VbeSignature        BYTE  4 dup(?)
      VbeVersion          WORD  ?
      OemStringPtr        DWORD ?
      Capabilities        BYTE  4 dup(?)
      VideoModePtr        DWORD ?
      TotalMemory         WORD  ?
      OemSoftwareRev      WORD  ?
      OemVendorNamePtr    DWORD ?
      OemProductNamePtr   DWORD ?
      OemProductRevPtr    DWORD ?
      Reserved            BYTE  222 dup(?)
      OemData             BYTE  256 dup(?)
    VbeInfoBlock ends    

.data
    vbeinfo VbeInfoBlock <'VBE2'>
.code
.startup
;     

    mov   ax, 4f00h       ; Return VBE Controller Information
    push  ds
    pop   es
    mov   di, OFFSET vbeinfo
    int   10h
    cmp   ax, 4fh
    je    @F
    print NL, "Return VBE Controller Information *error*"
    jmp   fini
  @@:

    print NL, "VbeSignature = '", ADDR vbeinfo.VbeSignature, "'"

    invoke w2hex, vbeinfo.VbeVersion, ADDR outbuf
    print NL, "VbeVersion = ", ADDR outbuf

    print NL, "OemString = "
    invoke print_far_string,  WORD PTR vbeinfo.OemStringPtr[2],
                              WORD PTR vbeinfo.OemStringPtr

    print NL, "Capabilities:"
    .IF vbeinfo.Capabilities & 1
      print NL, "  DAC width is switchable to 8 bit per primary color"
    .ELSE
      print NL, "  DAC is fixed width, with 6 bit per primary color"
    .ENDIF
    .IF vbeinfo.Capabilities & 2
      print NL, "  Controller is not VGA compatible"
    .ELSE
      print NL, "  Controller is VGA compatible"
    .ENDIF
    .IF vbeinfo.Capabilities & 4
      print NL, "  When programming large blocks...use the blank bit in Function 09h"
    .ELSE
      print NL, "  Normal RAMDAC operation"
    .ENDIF
    .IF vbeinfo.Capabilities & 8
      print NL, "  Hardware stereoscopic signaling supported by controller"
      .IF  vbeinfo.Capabilities & 16
        print NL, "  Stereo signaling supported via VESA EVC connector"
      .ELSE
        print NL, "  Stereo signaling supported via external VESA stereo connector"
      .ENDIF
    .ELSE
      print NL, "  No hardware stereoscopic signaling support"
    .ENDIF

    print NL, "Supported VBE display modes:", NL
    mov   es, WORD PTR vbeinfo.VideoModePtr[2]
    mov   si, WORD PTR vbeinfo.VideoModePtr
    xor   bx, bx
    print "  "
  @@:
    mov   ax, es:[si]
    cmp   ax, -1
    je    @F
    add   si, 2
    invoke w2hex, ax, ADDR outbuf    
    .IF bx > 7
      print NL, "  "
      xor   bx, bx
    .ENDIF
    print ADDR outbuf, "h, "
    inc   bx
    jmp   @B
  @@:
    print BS, BS, " "

    mov   ax, vbeinfo.TotalMemory
    mov   cx, 64
    mul   cx
    invoke w2dec, ax, ADDR outbuf
    print NL, "TotalMemory = ", ADDR outbuf, "KB"
    
    invoke w2hex, vbeinfo.OemSoftwareRev, ADDR outbuf
    print NL, "OemSoftwareRev = ", ADDR outbuf

    print NL, "OemVendorName = "
    invoke print_far_string,  WORD PTR vbeinfo.OemVendorNamePtr[2],
                              WORD PTR vbeinfo.OemVendorNamePtr

    print NL,"OemProductName = "
    invoke print_far_string,  WORD PTR vbeinfo.OemProductNamePtr[2],
                              WORD PTR vbeinfo.OemProductNamePtr

    print NL,"OemProductRev = "
    invoke print_far_string,  WORD PTR vbeinfo.OemProductRevPtr[2],
                              WORD PTR vbeinfo.OemProductRevPtr

    ; Search VGA BIOS for Protected Mode Information Block.    
    push  0c000h
    pop   es
    mov   cx,8000h                  ; 32K
  @@:    
    cmp   DWORD PTR es:[bx],'DIMP'  ; actual string is 'PMID'
    je    @F
    inc   bx
    dec   cx
    jnz   @B
    print NL, "Protected Mode Information Block not found"
    jmp   fini
  @@:
    print NL, "Protected Mode Information Block found"

  fini:

    print NL, NL, "Press any normal key to exit..."
    call waitkey
    .exit

; 

end
